Coin: ScXMLStateElt Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Member Functions | Static Public Member Functions | Protected Attributes | List of all members
ScXMLStateElt Class Reference
State Chart XML Classes

implements the <state> SCXML element. More...

`#include <Inventor/scxml/ScXMLStateElt.h>`

Inheritance diagram for ScXMLStateElt:

## Public Member Functions
virtual SoType | getTypeId (void) const
| Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.
| ScXMLStateElt (void)
virtual | ~ScXMLStateElt (void)
virtual void | setSrcAttribute (const char *src)
const char * | getSrcAttribute (void) const
virtual void | setInitialAttribute (const char *initial)
const char * | getInitialAttribute (void) const
virtual SbBool | handleXMLAttributes (void)
virtual void | copyContents (const ScXMLElt *rhs)
virtual const ScXMLElt * | search (const char *attrname, const char *attrvalue) const
virtual void | setOnEntry (ScXMLOnEntryElt *onentry)
virtual ScXMLOnEntryElt * | getOnEntry (void) const
virtual void | setOnExit (ScXMLOnExitElt *onexit)
virtual ScXMLOnExitElt * | getOnExit (void) const
virtual int | getNumTransitions (void) const
virtual ScXMLTransitionElt * | getTransition (int idx) const
virtual void | addTransition (ScXMLTransitionElt *transition)
virtual void | removeTransition (ScXMLTransitionElt *transition)
virtual void | clearAllTransitions (void)
virtual void | setInitial (ScXMLInitialElt *initial)
virtual ScXMLInitialElt * | getInitial (void) const
virtual int | getNumStates (void) const
virtual ScXMLStateElt * | getState (int idx) const
virtual void | addState (ScXMLStateElt *state)
virtual void | removeState (ScXMLStateElt *state)
virtual void | clearAllStates (void)
virtual int | getNumParallels (void) const
virtual ScXMLParallelElt * | getParallel (int idx) const
virtual void | addParallel (ScXMLParallelElt *state)
virtual void | removeParallel (ScXMLParallelElt *state)
virtual void | clearAllParallels (void)
virtual int | getNumFinals (void) const
virtual ScXMLFinalElt * | getFinal (int idx) const
virtual void | addFinal (ScXMLFinalElt *state)
virtual void | removeFinal (ScXMLFinalElt *state)
virtual void | clearAllFinals (void)
virtual int | getNumHistories (void) const
virtual ScXMLHistoryElt * | getHistory (int idx) const
virtual void | addHistory (ScXMLHistoryElt *history)
virtual void | removeHistory (ScXMLHistoryElt *history)
virtual void | clearAllHistories (void)
virtual int | getNumAnchors (void) const
virtual ScXMLAnchorElt * | getAnchor (int idx) const
virtual void | addAnchor (ScXMLAnchorElt *anchor)
virtual void | removeAnchor (ScXMLAnchorElt *anchor)
virtual void | clearAllAnchors (void)
virtual void | setDataModel (ScXMLDataModelElt *datamodel)
virtual ScXMLDataModelElt * | getDataModel (void) const
SbBool | isAtomicState (void) const
Public Member Functions inherited from ScXMLAbstractStateElt
virtual void | setIdAttribute (const char *id)
const char * | getIdAttribute (void) const
Public Member Functions inherited from ScXMLElt
void | setXMLAttribute (const char *attribute, const char *value)
const char * | getXMLAttribute (const char *attribute) const
ScXMLElt * | clone (void) const
virtual void | setContainer (ScXMLElt *container)
ScXMLElt * | getContainer (void) const
SbBool | isContainedIn (const ScXMLElt *object) const
Public Member Functions inherited from ScXMLObject
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.

## Static Public Member Functions
static ScXMLEltReader * | getElementReader (void)
static SoType | getClassTypeId (void)
static void * | createInstance (void)
static void | initClass (void)
static void | cleanClass (void)
Static Public Member Functions inherited from ScXMLAbstractStateElt
static SoType | getClassTypeId (void)
static void | initClass (void)
static void | cleanClass (void)
Static Public Member Functions inherited from ScXMLElt
static SoType | getClassTypeId (void)
static void | initClass (void)
static void | cleanClass (void)
Static Public Member Functions inherited from ScXMLObject
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | cleanClass (void)
| Does the opposite of initClass, deallocates any class specific resources and resets the class to an uninitialized state with respect to the Coin type system.

## Protected Attributes
char * | src
char * | initial
Protected Attributes inherited from ScXMLAbstractStateElt
char * | id

## Additional Inherited Members
Static Protected Member Functions inherited from ScXMLElt
static void | registerClassType (const char *xmlns, const char *classname, SoType type)
static void | registerInvokeClassType (const char *xmlns, const char *targettype, const char *source, SoType type)
Static Protected Member Functions inherited from ScXMLObject
static void | registerClassType (const char *xmlns, const char *classname, SoType type)
static void | registerInvokeClassType (const char *xmlns, const char *targettype, const char *source, SoType type)

## Detailed Description

implements the <state> SCXML element.

Since
  Coin 3.0

## Constructor & Destructor Documentation

## ◆ ScXMLStateElt()

ScXMLStateElt::ScXMLStateElt | ( | void |  | ) |

Constructor.

## ◆ ~ScXMLStateElt()

ScXMLStateElt::~ScXMLStateElt | ( | void |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getTypeId()

SoType ScXMLStateElt::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

See also
  SoBase::getTypeId() const

Implements ScXMLAbstractStateElt.

## ◆ setSrcAttribute()

void ScXMLStateElt::setSrcAttribute | ( | const char * | srcstr | ) |
| virtual

Sets the XML 'src' attribute for the SCXML <state> element. To get the attribute value interpreted and taken action upon, you will also need to [FIXME]

## ◆ getSrcAttribute()

const char * ScXMLStateElt::getSrcAttribute | ( | void |  | ) | const
| inline

Returns the XML 'src' attribute for this SCXML <state> element.

## ◆ setInitialAttribute()

void ScXMLStateElt::setInitialAttribute | ( | const char * | initialstr | ) |
| virtual

Sets the XML 'initial' attribute for the SCXML <state> element. If this value is set, the state should not contain an <initial> element, and vice versa.

When set, this value must be the value of a descendant an identifier for a child state.

See also
  ScXMLInitialElt

## ◆ getInitialAttribute()

const char * ScXMLStateElt::getInitialAttribute | ( | void |  | ) | const
| inline

Returns the XML 'initial' attribute for the SCXML <state> element.

## ◆ handleXMLAttributes()

SbBool ScXMLStateElt::handleXMLAttributes | ( | void |  | ) |
| virtual

This method is called when the file reader has set all the XML attributes on the object, and wants the object to handle them and report if the values were OK or if a read error should be produced.

Returns
  TRUE if the attributes are OK, and FALSE on error.

This base class implementation does nothing and just returns TRUE.

Reimplemented from ScXMLAbstractStateElt.

## ◆ copyContents()

void ScXMLStateElt::copyContents | ( | const ScXMLElt * | rhs | ) |
| virtual

Reimplemented from ScXMLAbstractStateElt.

## ◆ search()

const ScXMLElt * ScXMLStateElt::search | ( | const char * | attrname,
|  | const char * | attrvalue ) const
| virtual

This method searches the SCXML structure for an element with the given attribute value for the given attribute.

Returns NULL if nothing was found.

This function needs to be reimplemented to traverse child elements.

Reimplemented from ScXMLAbstractStateElt.

## ◆ isAtomicState()

SbBool ScXMLStateElt::isAtomicState | ( | void |  | ) | const

Returns TRUE if this is an "atomic state", which means that it has no sub-states but contains executable content.

The documentation for this class was generated from the following files:

- ScXMLStateElt.h
- ScXMLStateElt.cpp